/*
 * PM 2018
 * Proiect - Skittles Sorter
 * Stan Stefanita 334CC
 */
 
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <inttypes.h>
#include "tcs3200.h"
#include "lcd.h"

unsigned int MeasureR();
unsigned int MeasureG();
unsigned int MeasureB();
unsigned int MeasureC();

void sort(void) {
	unsigned int r2, g2, b2;
	unsigned int r, g, b;
	unsigned int v1, v2, d;
	int count = 0;
	int servo_angle = 130;
	
	char buffer1[16];
	char buffer2[16];
	
	/* Setez pinul PA0 ca iesire
	 * pentru backlight-ul LCD-ului
	 * si il activez
	 */
	DDRA |= (1 << PA0);
	PORTA |= (1 << PA0);
	
	
	while (1) {
		LCD_writeInstr(LCD_INSTR_clearDisplay);
        sprintf(buffer1,"Waiting for candy");
        LCD_printAt(0x00,buffer1);
		
		/* muta platforma pentru a pozitiona
		 * bomboana in dreptul senzorului de culoare
		 */
		OCR1A = 425;
		_delay_ms(250);
		
		
		TCSLEDOn();
		v1=MeasureC();
		
		_delay_ms(100);
		
		TCSLEDOff();
		v2=MeasureC();
		
		d=v1-v2;
		
		if(d>8000)
		{
			/* masoara valoarea RGB */
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			
			sprintf(buffer1,"Sorting Candy");
			LCD_printAt(0x00,buffer1);
			
			_delay_ms(250);
			
			TCSLEDOn();
			
			r = MeasureR();
			g = MeasureG();
			b = MeasureB();
			
			TCSLEDOff();
			
			unsigned int smallest;
		
			if(r < b)
			{
				if(r < g)
					smallest = r;
				else
					smallest = g;
			}
			else
			{
				if(b < g)
					smallest = b;
				else
					smallest = g;	
			}
			
			smallest = smallest / 10;
			
			r2 = r / smallest;
			g2 = g / smallest;
			b2 = b / smallest;
			
			sprintf(buffer1, "R:%lu G:%lu B:%lu", (unsigned long) r2, (unsigned long) g2, (unsigned long) b2);
			if (r2 == 10 && g2 == 10 && b2 == 10 && smallest > 200) {
				/* White */
				sprintf(buffer2, "White");
			}
			else if (r2 > b2 && r2 > g2 && b2 <= 12 && g2 <= 12 && r2 < 15) {
				/* Brown */
				sprintf(buffer2, "Brown");
				servo_angle = 170;
			}
			else if (r2 > b2 && r2 > g2 && b2 <= 12 && g2 <= 12) {
				/* Red */
				sprintf(buffer2, "Red");
				servo_angle = 210;
			}
			else if (r2 > b2 && g2 > b2 && r2 > g2 && b2 <= 12 && g2 < 15) {
				/* Orange */
				sprintf(buffer2, "Orange");
				servo_angle = 250;
			}
			else if (r2 > b2 && g2 > b2 && r2 > g2 && b2 <= 12) {
				/* Yellow */
				sprintf(buffer2, "Yellow");
				servo_angle = 310;
			}
			else if (g2 > b2 && g2 >= r2 && b2 <= 12) {
				/* Green */
				sprintf(buffer2, "Green");
				servo_angle = 370;
				
			}
			else if (b2 > g2 && b2 >= 15 && r2 <= 12) {
				/* Blue */
				sprintf(buffer2, "Blue");
				servo_angle = 410;
			}
			
			
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(0x00,buffer1);
			LCD_printAt(0x40,buffer2);
			
			OCR1A = 316;
			OCR1B = servo_angle;
			
			count = 0;

			_delay_ms(3000);
		} else {
			count++;	
		}
		
		if (count == 5 || count == 0) {
			OCR1A = 525;
			count = 0;
		}
		
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_printAt(0x00,buffer1);
		
		_delay_ms(1000);
	}
}

void init_servo(void)
{
	TCCR1A|=(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11);        //NON Inverted PWM
	TCCR1B|=(1<<WGM13)|(1<<WGM12)|(1<<CS11)|(1<<CS10); //PRESCALER=64 MODE 14(FAST PWM)
	
	ICR1=4999;  //fPWM=50Hz (Period = 20ms Standard).

	DDRD |= (1 << PD4) | (1 << PD5);   //PWM Pins as Out
	OCR1A = 525;
	OCR1B = 310;
	_delay_ms(2000);

}

int main(void) {
	
	/* initializare senzor culoare */
	InitTCS3200();
	TCSSetFrequency();
	
	/* initializare LCD */
	LCD_init();
	
	/* initializare PWM pentru control motoare servo */
	init_servo();
	
	sort();

    while(1);

	return 0;
}

unsigned int MeasureR()
{
	TCSSelectRed();
	unsigned int r;
	
	_delay_ms(10);
	r=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();
	
	return r/3.3;
}
unsigned int MeasureG()
{
	TCSSelectGreen();
	unsigned int r;
	
	_delay_ms(10);
	r=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();
	
	return r/3;
}
unsigned int MeasureB()
{
	TCSSelectBlue();
	unsigned int r;
	
	_delay_ms(10);
	r=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();
	
	return r/4.2;
}
unsigned int MeasureC()
{
	TCSSelectClear();
	unsigned int r;
	
	_delay_ms(10);
	r=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();	
	
	_delay_ms(10);
	r+=TCSMeasure();
	
	return r/3;	
}