/*******************************************************************************
TCS230 Colour Sensor AVR

Conexiuni
******************

ATmega324
S2  -> PB0
S3  -> PB1
OUT -> PB2
S1 -> PB6
S0 -> PB5

*******************************************************************************/


#ifndef TCS3200_H_
#define TCS3200_H_

//S2
#define TCS_S2_DDR DDRB
#define TCS_S2_PORT PORTB
#define TCS_S2_POS PB0

//S3
#define TCS_S3_DDR DDRB
#define TCS_S3_PORT PORTB
#define TCS_S3_POS PB1

//Out
#define TCS_OUT_DDR DDRB
#define TCS_OUT_PORT PINB
#define TCS_OUT_POS PB2

//OE
#define TCS_LED_DDR DDRB
#define TCS_LED_PORT PORTB
#define TCS_LED_POS PB3

//S1
#define TCS_S1_DDR DDRB
#define TCS_S1_PORT PORTB
#define TCS_S1_POS PB5

//S0
#define TCS_S0_DDR DDRB
#define TCS_S0_PORT PORTB
#define TCS_S0_POS PB6



#define	TCSS2High()	TCS_S2_PORT|=(1<<TCS_S2_POS)
#define	TCSS2Low()	TCS_S2_PORT&=~(1<<TCS_S2_POS)
#define	TCSS3High()	TCS_S3_PORT|=(1<<TCS_S3_POS)
#define	TCSS3Low()	TCS_S3_PORT&=~(1<<TCS_S3_POS)
#define TCSLEDOn()	TCS_LED_PORT|=(1<<TCS_LED_POS)
#define TCSLEDOff() TCS_LED_PORT&=~(1<<TCS_LED_POS)
#define TCSS1Low()	TCS_S1_PORT&=~(1<<TCS_S1_POS)
#define TCSS1High()	TCS_S1_PORT|=(1<<TCS_S1_POS)
#define TCSS0Low()	TCS_S0_PORT&=~(1<<TCS_S0_POS)
#define TCSS0High()	TCS_S0_PORT|=(1<<TCS_S0_POS)

void InitTCS3200();

void TCSSelectRed();
void TCSSelectGreen();
void TCSSelectBlue();
void TCSSelectClear();
void TCSSetFrequency();
unsigned int TCSMeasure();


#endif /* TCS3200_H_ */